/*
24nRCT[{pXVXe
15sec̃C^[o^C}荞݂pāC
\tgEFA24ñpX|[go͂B
ITU1̃C^[o^C}pB
PWMF20msecB

OUTPORT0@bit0@F@n0
OUTPORT0@bit1@F@n1
OUTPORT0@bit2@F@n2
OUTPORT0@bit3@F@n3
    F
OUTPORT1@bit0@F@n8
OUTPORT1@bit1@F@n9
OUTPORT1@bit2@F@n10
OUTPORT1@bit3@F@n11
    F
OUTPORT2@bit0@F@n16
OUTPORT2@bit1@F@n17
OUTPORT2@bit2@F@n18
OUTPORT2@bit3@F@n19
    F
OUTPORT2@bit7@F@n23

̃vOł̃VAʐMeXg
A,B,C,...V,W,X̓ n0`24̃pXꂼ50sec
a,b,c,...v,w,x̓ n0`24̃pXꂼ50secZ
0̓              n0`24̃pXׂ1500sec̒ɂ
1̓              n0`24̃pXׂĈقȂ钷ɂ
*/

#include "3048fone.h"
#include "h8_3048fone.h"

#define OUTPORT0 P1
#define OUTPORT1 PA
#define OUTPORT2 PB

#define PERIOD 20000 /*PWM(=20msec)*/
#define INTERVAL 15  /*荞ݎ15sec*/

typedef struct {
	unsigned char bytedata[3];
} tribyte_t;

typedef struct {
	int pulseWidth;
	int bitnum;
} pulsewidth_t;

/*pX͍ŏ1000,1000,1200,1000,1000,1000,2000,2000sec*/
/*              1200,1100,2000,1200,1800,1700,1700,2000sec*/
/*              1500,1100,2000,1300,1400,1500,2000,1600sec*/
/*Ƃ*/
/*ӂP@gpĂȂn̒l1500ɌŒ肷邱*/
/*ӂQ@l1000`2000Ƃ*/
int pulseWidth[24]={  /*Pʃsec*/
	1000,1000,1200,1000,1000,1000,2000,2000,
	1200,1100,2000,1200,1800,1700,1700,2000,
	1500,1100,2000,1300,1400,1500,2000,1600
};

tribyte_t tribyte[26]; /*؂ւrbgp^*/
int switchtime[26]; /*INTERVAL secŐĂ̐؂ւ*/
int switchindex; /*|C^*/
volatile int switchtimecurrent; /*̐؂ւiINTERVAL secŐj*/
volatile int tick; /*ݎiINTERVAL secŐj*/
int period; /*PWMiINTERVAL secŐj*/

pulsewidth_t b_pulseWidth[24];
tribyte_t b_tribyte[26];
int b_switchtime[26];
const tribyte_t initstate={{0xff,0xff,0xff}}; /**/
const tribyte_t mask[24]={
	{0xfe,0xff,0xff},{0xfd,0xff,0xff},{0xfb,0xff,0xff},{0xf7,0xff,0xff},
	{0xef,0xff,0xff},{0xdf,0xff,0xff},{0xbf,0xff,0xff},{0x7f,0xff,0xff},
	{0xff,0xfe,0xff},{0xff,0xfd,0xff},{0xff,0xfb,0xff},{0xff,0xf7,0xff},
	{0xff,0xef,0xff},{0xff,0xdf,0xff},{0xff,0xbf,0xff},{0xff,0x7f,0xff},
	{0xff,0xff,0xfe},{0xff,0xff,0xfd},{0xff,0xff,0xfb},{0xff,0xff,0xf7},
	{0xff,0xff,0xef},{0xff,0xff,0xdf},{0xff,0xff,0xbf},{0xff,0xff,0x7f},
};

void turndownBit(tribyte_t *p,int bitnum)
{
	int i;
	for (i=0;i<3;i++) {
		p->bytedata[i]&=mask[bitnum].bytedata[i];
	}
}


/*XCb`O쐬b_̂ϐɍ*/
/*Lf[^Ԃ*/
int makeSwitchInfo(void)
{
	int i,j;
	pulsewidth_t tmp;
	for (i=0;i<24;i++) {
		b_pulseWidth[i].pulseWidth=(pulseWidth[i]+(INTERVAL>>1))/INTERVAL;
		b_pulseWidth[i].bitnum=i;
	}
	/*ɕבւ*/
	for (i=0;i<24-1;i++) {
		for (j=i+1;j<24;j++) {
			if (b_pulseWidth[j].pulseWidth<b_pulseWidth[i].pulseWidth) {
				tmp=b_pulseWidth[j];
				b_pulseWidth[j]=b_pulseWidth[i];
				b_pulseWidth[i]=tmp;
			}
		}
	}
	b_tribyte[0]=initstate;
	b_switchtime[0]=0;
	j=0;
	for (i=0;i<24;i++) {
		if (b_pulseWidth[i].pulseWidth==b_switchtime[j]) {
			turndownBit(&b_tribyte[j],b_pulseWidth[i].bitnum);
		} else {
			j++;
			b_tribyte[j]=b_tribyte[j-1];
			turndownBit(&b_tribyte[j],b_pulseWidth[i].bitnum);
			b_switchtime[j]=b_pulseWidth[i].pulseWidth;
		}
	}
	b_switchtime[++j]=0;
	b_tribyte[j]=b_tribyte[j-1];
	return j+1;
}

/*XCb`Ogpf[^̈ɃRs[*/
void moveSwitchingData(int num)
{
	int i;
	for (i=0;i<num;i++) {
		tribyte[i]=b_tribyte[i];
		switchtime[i]=b_switchtime[i];
	}
}

/*XCb`O̐Ə*/
/*XCb`Ȍ͂̊֐ōs*/
void renewSwitchingData(void)
{
	int num;
	num=makeSwitchInfo();
	/*pXƒ̓XCb`O񏑂͍s킸C҂ɂȂ*/
	while (tick<1500/INTERVAL && switchtimecurrent && period-100<tick);
	moveSwitchingData(num);
}

main()
{
	int num;
	char ch;
	int i;
	initLed();
	initSCI1();
	initTimer1Int(INTERVAL); /*INTERVALsec̃C^[o^C}荞*/
	OUTPORT0.DDR=0xff; /*|[g̏o͐ݒ*/
	OUTPORT1.DDR=0xff; /*|[g̏o͐ݒ*/
	OUTPORT2.DDR=0xff; /*|[g̏o͐ݒ*/
	switchindex=switchtimecurrent=tick=0;
	period=PERIOD/INTERVAL;
	num=makeSwitchInfo();
	moveSwitchingData(num);
	E_INT();
	startTimer1();
	turnOnLed(0);
	while (1) {
		ch=getCharSCI1();
		if ('A'<=ch && ch<='X') {
			i=ch-'A';
			pulseWidth[i]+=50;
			if (2000<pulseWidth[i]) pulseWidth[i]=2000;
		} else if ('a'<=ch && ch<='x') {
			i=ch-'a';
			pulseWidth[i]-=50;
			if (pulseWidth[i]<1000) pulseWidth[i]=1000;
		} else if (ch=='0') {
			for (i=0;i<24;i++) pulseWidth[i]=1500;
		} else if (ch=='1') {
			for (i=0;i<24;i++) pulseWidth[i]=1000+40*i;
		}
		renewSwitchingData();
	}
}

#pragma asm
	.SECTION    MYVEC, DATA, LOCATE=H'000070
	.ORG        H'000070  ;IMIA1
	.DATA.L     _TimerIntFunc
	.SECTION    P,CODE,ALIGN=2 ;YĂ͂Ȃ
#pragma endasm
#define clearTimer1Flag() (ITU1.TSR.BIT.IMFA=0)

#pragma interrupt (TimerIntFunc)
void TimerIntFunc() /*^C}荞݃[`*/
{
	static int cnt=0,blink=0;
	char *p;
	if (tick++==switchtimecurrent) {
		p=(char *)&tribyte[switchindex];
		OUTPORT0.DR.BYTE=*p++;
		OUTPORT1.DR.BYTE=*p++;
		OUTPORT2.DR.BYTE=*p;
		switchtimecurrent=switchtime[++switchindex];
	} else if (tick==period) {
		switchindex=switchtimecurrent=tick=0;
		if (++cnt==25) {
			cnt=0;
			P5.DR.BIT.B1=blink=1-blink;
		}
	}
	clearTimer1Flag();  /*^C}Xe[^XtÕNA YȂ*/
}
